// AmpmodDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dsp.h"
#include "AmpmodDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAmpmodDlg dialog


CAmpmodDlg::CAmpmodDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAmpmodDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAmpmodDlg)
	m_ApplyTo = -1;
	m_ModDepth = 0;
	m_ModFreq = 1.0;
	m_Phase = 0;
	m_WaveForm = 0;
	//}}AFX_DATA_INIT
}


void CAmpmodDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAmpmodDlg)
	DDX_CBIndex(pDX, IDC_APPLYTO, m_ApplyTo);
	DDX_Slider(pDX, IDC_MODDEPTH, m_ModDepth);
	DDX_Text(pDX, IDC_MODFREQ, m_ModFreq);
	DDV_MinMaxDouble(pDX, m_ModFreq, 0.1, m_HalfRate);
	DDX_Text(pDX, IDC_PHASE, m_Phase);
	DDV_MinMaxInt(pDX, m_Phase, 0, 359);
	DDX_Radio(pDX, IDC_WAVEFORM, m_WaveForm);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAmpmodDlg, CDialog)
	//{{AFX_MSG_MAP(CAmpmodDlg)
	ON_WM_VSCROLL()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAmpmodDlg message handlers

BOOL CAmpmodDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	if (!m_ApplyTo)
	{
		CComboBox *cb = (CComboBox *)GetDlgItem(IDC_APPLYTO);
		cb->DeleteString(1);
	}
	CSliderCtrl *sl = (CSliderCtrl *)GetDlgItem(IDC_MODDEPTH);
	sl->SetRangeMin(0);
	sl->SetRangeMax(60);
	sl->SetTicFreq(4);
	char s[50];
	if (!m_IsSynth)
		sprintf(s, "  (0.1 - %d ):", m_HalfRate);
	else
	{
		sprintf(s, " \n(0.1 - %d ):", m_HalfRate);
		SetDlgItemText(IDC_STATIC1, " ");
		SetWindowText("");
	}
	SetDlgItemText(IDC_MODFREQTEXT, s);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAmpmodDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	
	int pos;
	double p;

	CSliderCtrl *sl = (CSliderCtrl *)pScrollBar;
	char s[20];

	pos = -sl->GetPos();
	p = pow(10, (double)pos / 20) * 100;
	sprintf(s, "%d \n(%.2f%c)", pos, p, '%');
	SetDlgItemText(IDC_VAL1, s);

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CAmpmodDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_MODDEPTH));
}
