// DSPDoc.cpp : implementation of the CDSPDoc class
//

#include "stdafx.h"
#include "DSP.h"

#include "DSPDoc.h"
#include "DSPView.h"
#include "InfoDlg.h"
#include "MainFrm.h"
#include "PlayDialog.h"
#include "ProgressDlg.h"
#include "filters.h"
//#include "3DWnd.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDSPDoc

IMPLEMENT_DYNCREATE(CDSPDoc, CDocument)

BEGIN_MESSAGE_MAP(CDSPDoc, CDocument)
	//{{AFX_MSG_MAP(CDSPDoc)
	ON_COMMAND(ID_CONVERT, OnConvert)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_CLEAR, OnEditClear)
	ON_COMMAND(ID_FILEINFO, OnFileinfo)
	ON_COMMAND(ID_PLAY, OnPlay)
	ON_UPDATE_COMMAND_UI(ID_FILE_NEW, OnUpdateFileNew)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE, OnUpdateFileSave)
	ON_UPDATE_COMMAND_UI(ID_FILE_SAVE_AS, OnUpdateFileSaveAs)
	ON_UPDATE_COMMAND_UI(ID_CONVERT, OnUpdateConvert)
	ON_UPDATE_COMMAND_UI(ID_STOP, OnUpdateStop)
	ON_COMMAND(ID_PLAYALL, OnPlayall)
	ON_UPDATE_COMMAND_UI(ID_PLAY, OnUpdatePlay)
	ON_UPDATE_COMMAND_UI(ID_PLAYALL, OnUpdatePlayall)
	ON_UPDATE_COMMAND_UI(ID_PAUSE, OnUpdatePause)
	ON_COMMAND(ID_STOP, OnStop)
	ON_UPDATE_COMMAND_UI(ID_REWIND, OnUpdateRewind)
	ON_UPDATE_COMMAND_UI(ID_FORWARD, OnUpdateForward)
	ON_UPDATE_COMMAND_UI(ID_GOTOEND, OnUpdateGotoend)
	ON_UPDATE_COMMAND_UI(ID_GOTOSTART, OnUpdateGotostart)
	ON_COMMAND(ID_PAUSE, OnPause)
	ON_UPDATE_COMMAND_UI(ID_APP_ABOUT, OnUpdateAppAbout)
	ON_UPDATE_COMMAND_UI(ID_FILEINFO, OnUpdateFileinfo)
	ON_COMMAND(ID_PLAYPARAMS, OnPlayparams)
	ON_UPDATE_COMMAND_UI(ID_PLAYPARAMS, OnUpdatePlayparams)
	ON_UPDATE_COMMAND_UI(ID_LOPASS, OnUpdateLopass)
	ON_COMMAND(ID_LOPASS, OnLopass)
	ON_COMMAND(ID_HIPASS, OnHipass)
	ON_UPDATE_COMMAND_UI(ID_HIPASS, OnUpdateHipass)
	ON_UPDATE_COMMAND_UI(ID_BANDPASS, OnUpdateBandpass)
	ON_COMMAND(ID_BANDPASS, OnBandpass)
	ON_COMMAND(ID_BANDREJECT, OnBandreject)
	ON_UPDATE_COMMAND_UI(ID_BANDREJECT, OnUpdateBandreject)
	ON_UPDATE_COMMAND_UI(ID_USERFIR, OnUpdateUserfir)
	ON_COMMAND(ID_USERFIR, OnUserfir)
	ON_COMMAND(ID_CLEAR, OnClear)
	ON_COMMAND(ID_FILE_RECORD, OnFileRecord)
	ON_UPDATE_COMMAND_UI(ID_REMOVEDC, OnUpdateRemovedc)
	ON_COMMAND(ID_REMOVEDC, OnRemovedc)
	ON_COMMAND(ID_MOVINGAVG, OnMovingavg)
	ON_UPDATE_COMMAND_UI(ID_MOVINGAVG, OnUpdateMovingavg)
	ON_UPDATE_COMMAND_UI(ID_CHEBYSHEV, OnUpdateChebyshev)
	ON_COMMAND(ID_CHEBYSHEV, OnChebyshev)
	ON_UPDATE_COMMAND_UI(ID_ECHO, OnUpdateEcho)
	ON_COMMAND(ID_ECHO, OnEcho)
	ON_UPDATE_COMMAND_UI(ID_AMPMOD, OnUpdateAmpmod)
	ON_COMMAND(ID_AMPMOD, OnAmpmod)
	ON_UPDATE_COMMAND_UI(ID_CONVOLUTION, OnUpdateConvolution)
	ON_COMMAND(ID_CONVOLUTION, OnConvolution)
	ON_UPDATE_COMMAND_UI(ID_LOGARITHMING, OnUpdateLogarithming)
	ON_COMMAND(ID_LOGARITHMING, OnLogarithming)
	ON_UPDATE_COMMAND_UI(ID_FOURIER, OnUpdateFourier)
	ON_COMMAND(ID_FOURIER, OnFourier)
	ON_UPDATE_COMMAND_UI(ID_IIRDESIGN, OnUpdateIirdesign)
	ON_COMMAND(ID_IIRDESIGN, OnIirdesign)
	ON_UPDATE_COMMAND_UI(ID_3DDESIGN, OnUpdate3ddesign)
	ON_COMMAND(ID_3DDESIGN, On3ddesign)
	ON_UPDATE_COMMAND_UI(ID_SYNTH, OnUpdateSynth)
	ON_COMMAND(ID_SYNTH, OnSynth)
	ON_UPDATE_COMMAND_UI(ID_SETSAMPLES, OnUpdateSetsamples)
	ON_COMMAND(ID_SETSAMPLES, OnSetsamples)
	ON_UPDATE_COMMAND_UI(ID_ADDNOISE, OnUpdateAddnoise)
	ON_COMMAND(ID_ADDNOISE, OnAddnoise)
	ON_UPDATE_COMMAND_UI(ID_FADE, OnUpdateFade)
	ON_COMMAND(ID_FADE, OnFade)
	ON_UPDATE_COMMAND_UI(ID_PITCHSHIFT, OnUpdatePitchshift)
	ON_COMMAND(ID_PITCHSHIFT, OnPitchshift)
	ON_UPDATE_COMMAND_UI(ID_CHORUS, OnUpdateChorus)
	ON_COMMAND(ID_CHORUS, OnChorus)
	ON_UPDATE_COMMAND_UI(ID_REVERB, OnUpdateReverb)
	ON_COMMAND(ID_REVERB, OnReverb)
	ON_UPDATE_COMMAND_UI(ID_REVERSE, OnUpdateReverse)
	ON_COMMAND(ID_REVERSE, OnReverse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDSPDoc construction/destruction

CDSPDoc *pDoc;
WAVEHDR wh;
CProgressDlg *pdlg;

CDSPDoc::CDSPDoc()
{
	// TODO: add one-time construction code here
	data = NULL;	
	hwo = 0;
	IsPlaying = false;
	Paused = false;
	pDoc = this;
	m_Freq = 0;
	m_NumDevs = waveOutGetNumDevs();
}

CDSPDoc::~CDSPDoc()
{
	if (IsPlaying) OnStop();
}

BOOL CDSPDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	int smp_rate = GetSampleRate(newdoc.m_SampleRate);

	strcpy(h.RIFF, "RIFF");
	strcpy(h.wavefmt, "WAVEfmt ");
	h.size = sizeof(h.w) + 2;
	h.w.wFormatTag = WAVE_FORMAT_PCM;
	h.w.nChannels = newdoc.m_Channels + 1;
	h.w.nSamplesPerSec = smp_rate;
	h.wBitsPerSample = 1 << (newdoc.m_SampleSize + 3);
	h.w.nBlockAlign = h.w.nChannels * (newdoc.m_SampleSize + 1);
	h.w.nAvgBytesPerSec = smp_rate * h.w.nBlockAlign;
	strcpy(h.data, "data");
	h.size2 = (h.w.nAvgBytesPerSec * newdoc.m_DocSize);
	h.file_length = sizeof(h.w) + h.size2 - 8;

	data = new char[h.size2];
	if (!newdoc.m_SampleSize)
		memset(data, 0x80, h.size2);
	else
		memset(data, 0x00, h.size2);

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CDSPDoc serialization

void CDSPDoc::Serialize(CArchive& ar)
{
	if (ar.IsLoading())
	{
		WaveHeader h2;
		ar.Read(&h2, sizeof(h2));
		if (!CheckFormat(h2)) 
		{
			DeleteContents();
			UpdateAllViews(NULL);
			throw AfxThrowArchiveException(CArchiveException::badIndex, ar.GetFile()->GetFileName());
		}
		memcpy(&h, &h2, sizeof(h));
		data = new char[h.size2];
	}

	unsigned long step = h.size2 / 100, n, cur_pos = 0;
	if (step < 512000) step = 512000;
	n = h.size2 / step;
	if (h.size2 % step) n++;

	if (ar.IsStoring())
		ar.Write(&h, sizeof(h));

	for (unsigned int i = 0; i < n; i++)
	{
		if (cur_pos + step <= h.size2)
		{
			if (ar.IsStoring())
				ar.Write(data + cur_pos, step);
			else
				ar.Read(data + cur_pos, step);
		}
		else
		{
			if (ar.IsStoring())
				ar.Write(data + cur_pos, h.size2 - cur_pos);
			else
				ar.Read(data + cur_pos, h.size2 - cur_pos);
		}
		pdlg->m_Progress.SetPos(int((double)cur_pos / h.size2 * 100.0));
		cur_pos += step;
	}
}

void CDSPDoc::DeleteContents()
{
	if (data != NULL)
	{
		delete data;
		data = NULL;
	}
}

bool CDSPDoc::CheckFormat(WaveHeader h)
{
	if (h.RIFF[0] != 'R' ||
		h.RIFF[1] != 'I' ||
		h.RIFF[2] != 'F' ||
		h.RIFF[3] != 'F') return false;

	if (h.w.wFormatTag != WAVE_FORMAT_PCM) return false;

	if (h.wBitsPerSample != 16 &&
		h.wBitsPerSample != 8) return false;

	if (h.w.nChannels != 1 &&
		h.w.nChannels != 2) return false;

	if (h.data[0] != 'd' ||
		h.data[1] != 'a' ||
		h.data[2] != 't' ||
		h.data[3] != 'a') return false;

	return true;
}

/////////////////////////////////////////////////////////////////////////////
// CDSPDoc diagnostics

#ifdef _DEBUG
void CDSPDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CDSPDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CDSPDoc commands

void CDSPDoc::OnConvert() 
{
	// TODO: Add your command handler code here
	if (dlg.DoModal() != IDOK) return;
	unsigned int smp_rate = GetSampleRate(dlg.m_SampleRate);
	double step = (double)h.w.nSamplesPerSec / smp_rate;
	double smp[2], pos = 0.0;
	int new_samples = int((double)h.size2 / GetSampleSize() / step);
	int new_channels = dlg.m_Channels + 1;
	int new_samplesize = new_channels * (dlg.m_SampleSize + 1);
	int percentage = 0, p = 0;
	int segs, seg_size = new_samples / 100;
	int i, j, n, k_size = 65, cut_off;
	double *kernel = NULL, db = (double)dlg.m_Volume / -20.0;
	bool Is16bit = (dlg.m_SampleSize == 1);
	bool MonoToStereo = (new_channels == 2 && h.w.nChannels == 1);
	bool StereoToMono = (new_channels == 1 && h.w.nChannels == 2);
	bool c8bitTo16bit = (Is16bit && h.wBitsPerSample == 8);
	bool c16bitTo8bit = (!Is16bit && h.wBitsPerSample == 16);
	CProgressDlg pd;

	if (smp_rate == h.w.nSamplesPerSec &&
		new_channels == h.w.nChannels &&
		Is16bit == (h.wBitsPerSample == 16)
		&& db == 0.0) return;

	if (dlg.m_ApplyFilter && smp_rate != h.w.nSamplesPerSec)
	{
		 if (smp_rate < h.w.nSamplesPerSec)
			 cut_off = smp_rate;
		 else
			 cut_off = h.w.nSamplesPerSec >> 1;
		 kernel = new double[k_size];
		 LowPassFIRKernel(k_size - 1, (double)cut_off / smp_rate, true, kernel);
	}

	if (dlg.m_ApplyFilter && smp_rate < h.w.nSamplesPerSec)
	{
		pd.m_Text = "   ...";
		pd.Create(IDD_PROGRESSDLG);
		SetProgressDlg(&pd);
		for (i = 0; i < h.w.nChannels; i++)
		{
			SampleData s(h.size2 / GetSampleSize(), data, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
			FIRFilter(s, k_size, kernel);
		}
		pd.DestroyWindow();
	}

	pd.m_Text = "   ...";
	pd.Create(IDD_PROGRESSDLG);

	char *new_data = new char[new_samples * new_samplesize];
	SampleData s1(h.size2 / GetSampleSize(), data, (h.wBitsPerSample == 16),
		(h.w.nChannels == 2), 0);
	SampleData s2(new_samples, new_data, Is16bit, (new_channels == 2), 0);

	if (seg_size < 65536) seg_size = 65536;
	segs = new_samples / seg_size;
	if (new_samples % seg_size) segs++;

	for (n = 0; n < segs; n++)
	{
		if (new_samples - p < seg_size) 
			seg_size = new_samples - p;
		for (i = 0; i < seg_size; i++)
		{
			for (j = 0; j < new_channels; j++)
			{
				if (!MonoToStereo)
					s1.Channel = j;
				smp[j] = s1.GetSample(int(pos));
				if (StereoToMono)
				{
					s1.Channel = 0;
					smp[0] = s1.GetSample(int(pos));
					s1.Channel = 1;
					smp[0] += s1.GetSample(int(pos));
					smp[0] *= 0.5;
				}
				if (c8bitTo16bit)
					smp[j] *= 256.0;
				if (c16bitTo8bit)
					smp[j] /= 256.0;
				smp[j] *= pow(10, db);
				s2.Channel = j;
				s2.SetSample(i + p, smp[j]);
			}
			pos += step;
		}
		p += seg_size;
		percentage = int((double)p * 100.0 / new_samples);
		pd.m_Progress.SetPos(percentage);
	}

	pd.DestroyWindow();

	if (dlg.m_ApplyFilter && smp_rate > h.w.nSamplesPerSec)
	{
		pd.m_Text = "   ...";
		pd.Create(IDD_PROGRESSDLG);
		SetProgressDlg(&pd);
		for (i = 0; i < new_channels; i++)
		{
			SampleData s(new_samples, new_data, Is16bit, (new_channels == 2), i);
			FIRFilter(s, k_size, kernel);
		}
		pd.DestroyWindow();
	}

	if (kernel) delete kernel;
	delete data;

	data = new_data;
	h.wBitsPerSample = 8 << (Is16bit ? 1 : 0);
	h.w.nChannels = new_channels;
	h.w.nBlockAlign = new_channels << (Is16bit ? 1 : 0);
	h.w.nSamplesPerSec = smp_rate;
	h.w.nAvgBytesPerSec = smp_rate * h.w.nBlockAlign;
	int diff = h.size2; 
	h.size2 = new_samples * new_samplesize;
	diff -= h.size2;
	h.file_length -= diff;
	
	SetModifiedFlag();
	UpdateAllViews(NULL);
}

int CDSPDoc::GetSampleSize()
{
	return (h.wBitsPerSample >> 3) * h.w.nChannels;
}

int CDSPDoc::GetSamples()
{
	return h.size2 / (h.w.nChannels * h.wBitsPerSample >> 3);
}

void CDSPDoc::OnEditCopy() 
{
	// TODO: Add your command handler code here
	POSITION pos = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(pos);
	HGLOBAL mem;
	int size = GetSampleSize();
	int size2 = size * v->GetSelectionSize();
	WaveHeader h2;
	char *data2;

	mem = GlobalAlloc(GMEM_MOVEABLE | GMEM_DDESHARE, size2 + sizeof(h));
	if (!mem)
	{
		v->MessageBox("    ");
		return;
	}
	h2 = h;
	h2.file_length -= size * GetSamples() - size2;
	h2.size2 = size2;
	data2 = (char *)GlobalLock(mem);
	memcpy(data2, (char *)&h2, sizeof(h2));
	memcpy(data2 + sizeof(h2), data + size * v->GetStartPos(), size2);
	GlobalUnlock(mem);

	if (!v->OpenClipboard())
	{
		v->MessageBox("   ");
		return;
	}

	if (!EmptyClipboard())
	{
		v->MessageBox("   ");
		CloseClipboard();
		return;
	}

	if (!SetClipboardData(CF_WAVE, mem))
	{
		v->MessageBox("     ");
		CloseClipboard();
		return;
	}

	if (!CloseClipboard())
	{
		v->MessageBox("   ");
		return;
	}
}

void CDSPDoc::OnEditPaste() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	HANDLE mem;
	char *data2, *buf;
	int size = GetSampleSize(), pos;
	WaveHeader h2;

	if (!v->OpenClipboard())
	{
		v->MessageBox("   ");
		return;
	}

	mem = GetClipboardData(CF_WAVE);

	if (!mem)
	{
		v->MessageBox("     ");
		CloseClipboard();
		return;
	}

	data2 = (char *)GlobalLock(mem);
	h2 = *((WaveHeader *)data2);
	if (h2.w.nAvgBytesPerSec == h.w.nAvgBytesPerSec &&
		h2.w.nBlockAlign == h.w.nBlockAlign &&
		h2.w.nChannels == h.w.nChannels &&
		h2.w.nSamplesPerSec == h.w.nSamplesPerSec &&
		h2.w.wFormatTag == h.w.wFormatTag &&
		h2.wBitsPerSample == h.wBitsPerSample)
	{
		buf = new char[size * GetSamples() + h2.size2];
		pos = size * v->GetStartPos();
		if (pos) memcpy(buf, data, pos);
		memcpy(buf + pos, data2 + sizeof(h2), h2.size2);
		pos += h2.size2;
		memcpy(buf + pos, data + size * v->GetStartPos(), 
			(GetSamples() - v->GetStartPos()) * size);
		delete data;
		data = buf;
		SetModifiedFlag();
	
		v->m_nSamples += h2.size2 / size;
		h.size2 += h2.size2;
		h.file_length += h2.size2;

		GlobalUnlock(mem);

		v->UpdateScrollParams();
		v->InvalidateRect(NULL, FALSE);
	}
	else
		v->MessageBox("     ,         ");

	if (!CloseClipboard())
	{
		v->MessageBox("   ");
		return;
	}
}

void CDSPDoc::OnEditCut() 
{
	// TODO: Add your command handler code here
	OnEditCopy();
	DeleteSelection();
}

void CDSPDoc::DeleteSelection()
{
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	int smp_size = GetSampleSize(), sel_size = v->GetSelectionSize();
	int buf_size = (GetSamples() - v->GetSelectionSize()) * smp_size;
	int size = v->GetStartPos() * smp_size, pos;
	char *buf = new char[buf_size];

	if (size) memcpy(buf, data, size);
	pos = size;
	size = (GetSamples() - v->GetEndPos() - 1) * smp_size;
	if (size) memcpy(buf + pos, data + smp_size * (v->GetEndPos() + 1), size);
	v->m_nSamples -= sel_size;
	h.size2 = v->m_nSamples * smp_size;
	h.file_length -= sel_size * smp_size;
	v->m_StartPos = v->m_EndPos = v->GetStartPos();
	delete data;
	data = buf;
	SetModifiedFlag();
	v->UpdateScrollParams();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnEditClear() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	if (v->MessageBox("  ?", NULL, MB_YESNO) == IDYES)
		DeleteSelection();
}

void CDSPDoc::OnFileinfo() 
{
	// TODO: Add your command handler code here
	int smp_size = GetSampleSize();
	int samples = h.size2 / smp_size;
	int msecs = int((double)samples * 1000.0 / h.w.nSamplesPerSec);
	int file_size = sizeof(h) + h.size2;

	CInfoDlg dlg;
	dlg.m_FileName = GetTitle();
	dlg.m_FileSize.Format("%ld ", file_size);
	if ((file_size % 10) == 2 ||
		(file_size % 10) == 3 ||
		(file_size % 10) == 4 &&
		((file_size % 100) > 20 ||
		(file_size % 100) < 10))
		dlg.m_FileSize += "";
	dlg.m_BitsPerSample.Format("%d ", h.wBitsPerSample);
	dlg.m_SampleRate.Format("%d ", h.w.nSamplesPerSec);
	dlg.m_nChannels.Format("%d", h.w.nChannels);
	if (h.w.nChannels > 1)
		dlg.m_nChannels += " ()";
	else
		dlg.m_nChannels += " ()";
	dlg.m_SampleSize.Format("%d ", smp_size);
	if (smp_size != 1)
		dlg.m_SampleSize += "";
	dlg.m_nSamples.Format("%ld", samples);
	dlg.m_FileTime.Format("%d ., %d ., %d .", msecs / 3600000,
		(msecs / 60000) % 60, (msecs / 1000) % 60);

	dlg.DoModal();
}

void CDSPDoc::OnPlay() 
{
	// TODO: Add your command handler code here
	if (Paused)
	{
		waveOutRestart(hwo);
		Paused = false;
		int count = 0;
		while (AfxGetApp()->OnIdle(count++));
		return;
	}

	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	int StartPos = v->GetStartPos();
	int EndPos = v->GetEndPos();
	if (StartPos != EndPos)
		Play(StartPos, EndPos);
	else
		Play(StartPos, v->m_nSamples - 1);
}

void CDSPDoc::OnUpdateFileNew(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateFileOpen(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateFileSave(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);		
}

void CDSPDoc::OnUpdateFileSaveAs(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateConvert(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateStop(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(IsPlaying && m_NumDevs);
}

void CDSPDoc::Play(int StartPos, int EndPos)
{
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	WAVEFORMATEX w;
	MMRESULT n;
	int SampleSize = GetSampleSize();

	CDSPDoc::StartPos = StartPos;
	CDSPDoc::EndPos = EndPos;

	EnableMenuItems(MF_DISABLED | MF_GRAYED);

	waveOutClose(hwo);
	w.wFormatTag = h.w.wFormatTag;
	w.nChannels = h.w.nChannels;
	
	if (!m_Freq)
		w.nSamplesPerSec = h.w.nSamplesPerSec;
	else
		w.nSamplesPerSec = GetSampleRate(m_Freq - 1);
	
	w.nAvgBytesPerSec = h.w.nAvgBytesPerSec;
	w.nBlockAlign = h.w.nBlockAlign;
	w.wBitsPerSample = h.wBitsPerSample;
	w.cbSize = 0;
	n = waveOutOpen(&hwo, WAVE_MAPPER, &w, (DWORD)waveOutProc, (DWORD)AfxGetInstanceHandle(), CALLBACK_FUNCTION);
	if (n != MMSYSERR_NOERROR)
	{
		v->MessageBox("   waveOutOpen", NULL, MB_OK | MB_ICONSTOP);
		return;
	}

	memset(&wh, 0, sizeof(wh));
	wh.lpData = data + StartPos * SampleSize;
	wh.dwBufferLength = (EndPos - StartPos + 1) * SampleSize;

	n = waveOutPrepareHeader(hwo, &wh, sizeof(wh));
	if (n != MMSYSERR_NOERROR)
	{
		v->MessageBox("   waveOutPrepareHeader", NULL, MB_OK | MB_ICONSTOP);
		IsPlaying = false;
		return;
	}

	n = waveOutWrite(hwo, &wh, sizeof(wh));
	if (n != MMSYSERR_NOERROR)
	{
		v->MessageBox("   waveOutWrite", NULL, MB_OK | MB_ICONSTOP);
		IsPlaying = false;
		return;
	}

	IsPlaying = true;
	int count = 0;
	while (AfxGetApp()->OnIdle(count++));
}

void CDSPDoc::OnPlayall() 
{
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	// TODO: Add your command handler code here
	Play(0, v->m_nSamples - 1);
}

void CDSPDoc::OnUpdatePlay(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable((!IsPlaying || Paused) && m_NumDevs);
}

void CDSPDoc::OnUpdatePlayall(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying && m_NumDevs);	
}

void CDSPDoc::OnUpdatePause(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(IsPlaying && !Paused && m_NumDevs);	
}

void CDSPDoc::OnStop() 
{
	// TODO: Add your command handler code here
	Paused = false;
	IsPlaying = false;
	waveOutReset(hwo);
	waveOutClose(hwo);
	EnableMenuItems(MF_ENABLED);
}

void CDSPDoc::OnUpdateRewind(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateForward(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateGotoend(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateGotostart(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnPause() 
{
	// TODO: Add your command handler code here
	waveOutPause(hwo);
	Paused = true;
}

void CALLBACK waveOutProc(HWAVEOUT hwo, UINT uMsg, DWORD dwInstance,
						  DWORD dwParam1, DWORD dwParam2)
{
	if (uMsg == WOM_DONE && hwo && pDoc->IsPlaying)
	{
		waveOutUnprepareHeader(hwo, &wh, sizeof(WAVEHDR));
		pDoc->EnableMenuItems(MF_ENABLED);
		pDoc->IsPlaying = false;
	}
}

void CDSPDoc::OnUpdateAppAbout(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnUpdateFileinfo(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::EnableMenuItems(UINT enable)
{
	CWnd *w = AfxGetMainWnd();
	if (w != NULL)
	{
		CMenu *menu = w->GetMenu();
		if (menu != NULL)
			for (int i = 0; i < 9; i++)
				if (i != 2 && i != 3)
					menu->EnableMenuItem(i, MF_BYPOSITION | enable);
		w->DrawMenuBar();
	}
}


BOOL CDSPDoc::OnOpenDocument(LPCTSTR lpszPathName) 
{
	CProgressDlg pd;
	pd.m_Text = "  ...";
	pd.Create(IDD_PROGRESSDLG);
	pdlg = &pd;
	if (!CDocument::OnOpenDocument(lpszPathName))
	{
		pd.DestroyWindow();
		OnNewDocument();
	}
	return TRUE;
}

void CDSPDoc::OnPlayparams() 
{
	// TODO: Add your command handler code here
	CPlayDialog dlg;
	dlg.m_Freq = m_Freq;
	dlg.DoModal();
	m_Freq = dlg.m_Freq;
}

void CDSPDoc::OnUpdatePlayparams(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying && m_NumDevs);	
}

void CDSPDoc::OnUpdateLopass(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnLopass() 
{
	// TODO: Add your command handler code here
	ApplyFilter(0, true, true, true);
}

void CDSPDoc::OnHipass() 
{
	// TODO: Add your command handler code here
	ApplyFilter(1, true, true, true);
}

void CDSPDoc::OnUpdateHipass(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnUpdateBandpass(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnBandpass() 
{
	// TODO: Add your command handler code here
	ApplyFilter(2, true, true, true);
}

void CDSPDoc::OnBandreject() 
{
	// TODO: Add your command handler code here
	ApplyFilter(3, true, true, true);	
}

void CDSPDoc::OnUpdateBandreject(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUpdateUserfir(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnUserfir() 
{
	// TODO: Add your command handler code here
	ApplyFilter(4, true, true, true);
}

void CDSPDoc::ApplyFilter(int type, bool IsFIR, bool Show, bool Apply)
{
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	int res = Show ? IDCANCEL : IDOK;
	int s1 = v->GetStartPos();
	int e1 = v->GetEndPos();
	int ApplyTo = (s1 != e1) ? 1 : 0;
	int samplerate = h.w.nSamplesPerSec;
	int k_size, i;
	int N, NumPoles, NumZeros;
	CString freq;
	freq.Format("%d", samplerate >> 1);

	if (IsFIR)
	{
		switch (type)
		{
			case 0: 
				if (Show)
				{
					lopass.m_Freq = "  (0 - " + freq + " ):";
					lopass.m_HalfRate = samplerate >> 1;
					lopass.m_ApplyTo = ApplyTo;
					res = lopass.DoModal(); 
				}
				k_size = lopass.m_KernelSize;
				ApplyTo = lopass.m_ApplyTo;
				break;
			case 1: 
				if (Show)
				{
					hipass.m_Freq = "  (0 - " + freq + " ):";
					hipass.m_HalfRate = samplerate >> 1;
					hipass.m_ApplyTo = ApplyTo;
					res = hipass.DoModal(); 
				}
				k_size = hipass.m_KernelSize;
				ApplyTo = hipass.m_ApplyTo;
				break;
			case 2: 
				if (Show)
				{
					bandpass.m_Freq1 = "  (0 - " + freq + " ):";
					bandpass.m_Freq2 = "  (0 - " + freq + " ):";
					bandpass.m_HalfRate = samplerate >> 1;
					bandpass.m_ApplyTo = ApplyTo;
					res = bandpass.DoModal(); 
				}
				k_size = bandpass.m_KernelSize;
				ApplyTo = bandpass.m_ApplyTo;
				break;
			case 3: 
				if (Show)
				{
					bandreject.m_Freq1 = "  (0 - " + freq + " ):";
					bandreject.m_Freq2 = "  (0 - " + freq + " ):";
					bandreject.m_HalfRate = samplerate >> 1;
					bandreject.m_ApplyTo = ApplyTo;
					res = bandreject.DoModal(); 
				}
				k_size = bandreject.m_KernelSize;
				ApplyTo = bandreject.m_ApplyTo;
				break;
			case 4: 
				if (Show)
				{
					userfir.m_HalfRate = samplerate >> 1;
					userfir.m_Bits = h.wBitsPerSample;
					userfir.m_ApplyTo = ApplyTo;
					res = userfir.DoModal(); 
				}
				k_size = userfir.m_KernelSize;
				ApplyTo = userfir.m_ApplyTo;
				break;
			case 5:
				if (Show)
				{
					condlg.m_ApplyTo = ApplyTo;
					res = condlg.DoModal();
				}
				ApplyTo = condlg.m_ApplyTo;
				k_size = condlg.m_KernelSize;
				break;
			case 6:
				if (Show)
				{
					dlg3d.m_ApplyTo = ApplyTo;
					dlg3d.m_SmpRate = samplerate;
					res = dlg3d.DoModal();
				}
				ApplyTo = dlg3d.m_ApplyTo;
				if (!(k_size = dlg3d.m_KernelSize)) return;
		}
	}
	else
	{
		switch (type)
		{
			case 0:
				if (Show)
				{
					chdlg.m_Freq = "  (0 - " + freq + " ):";
					chdlg.m_HalfRate = samplerate >> 1;
					chdlg.m_ApplyTo = ApplyTo;
					res = chdlg.DoModal(); 
				}
				ApplyTo = chdlg.m_ApplyTo;
				NumZeros = NumPoles = chdlg.m_NumPoles;
				if (NumPoles & 1)
				{
					NumPoles++;
					NumZeros++;
				}
				break;
			case 1:
				if (Show)
				{
					iirdlg.m_HalfRate = samplerate >> 1;
					iirdlg.m_ApplyTo = ApplyTo;
					res = iirdlg.DoModal();
				}
				ApplyTo = iirdlg.m_ApplyTo;
				NumPoles = iirdlg.cur_pole;
				NumZeros = iirdlg.cur_zero;
		}
	}

	if (res != IDOK || !Apply) return;
	v->InvalidateRect(NULL, FALSE);

	if (ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	pd.m_Text = "   ...";
	pd.Create(IDD_PROGRESSDLG);
	SetProgressDlg(&pd);

	if (IsFIR)
	{
		double *kernel;

		if (!(k_size & 1) && type != 6) k_size--;
		kernel = new double[k_size];

		switch (type)
		{
			case 0: 
				LowPassFIRKernel(k_size - 1,
					(double)lopass.m_Cutoff / samplerate,
					!lopass.m_WindowType, kernel);
				break;
			case 1: 
				HighPassFIRKernel(k_size - 1,
					(double)hipass.m_Cutoff / samplerate,
					!hipass.m_WindowType, kernel);
				break;
			case 2: 
				BandPassFIRKernel(k_size - 1,
					(double)bandpass.m_Cutoff1 / samplerate,
					(double)bandpass.m_Cutoff2 / samplerate,
					!bandpass.m_WindowType, kernel);
				break;
			case 3: 
				BandRejectFIRKernel(k_size - 1,
					(double)bandreject.m_Cutoff1 / samplerate,
					(double)bandreject.m_Cutoff2 / samplerate,
					!bandreject.m_WindowType, kernel);
				break;
			case 4: 
				UserFIRKernel(k_size - 1,
					userfir.m_Bands, userfir.m_Freqs, samplerate,
					!userfir.m_WindowType, kernel);
				break;
			case 5:
				memcpy(kernel, condlg.kernel, k_size * sizeof(double));
				break;
			case 6:
				dlg3d.GetKernel(kernel);
		}

		for (i = 0; i < h.w.nChannels; i++)
		{
			SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
			if (GetTransformFlag() == 2) 
				HomoFFTFIRFilter(s, k_size, kernel);
			else
			{
				if (k_size < 64)
					FIRFilter(s, k_size, kernel);
				else
					FFTFIRFilter(s, k_size, kernel);
			}
		}

		delete kernel;
	}
	else
	{
		int num_a = (NumZeros << 1) + 1;
		int num_b = NumPoles << 1;
		double *a = new double[(MAX_ZEROS << 1) + 1];
		double *b = new double[(MAX_POLES << 1) + 1];

		switch (type)
		{
			case 0: 
				GetChebyshevCoeff((double)chdlg.m_CutOff / h.w.nSamplesPerSec,
					NumPoles, chdlg.m_Ripple, !chdlg.m_IsLopass, a, b);
				break;
			case 1:
				GetPoleZeroCoeff(iirdlg.rp, iirdlg.wp, iirdlg.r0, iirdlg.w0,
					a, b, NumPoles, NumZeros, iirdlg.m_Normalize == 1);
		}

		for (i = 0; i < h.w.nChannels; i++)
		{
			SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
			IIRFilter(s, num_a, a, num_b, b + 1);
		}

		delete b;
		delete a;
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}


BOOL CDSPDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	// TODO: Add your specialized code here and/or call the base class
	CProgressDlg pd;
	if (IsPlaying) OnStop();
	pd.m_Text = "  ...";
	pd.Create(IDD_PROGRESSDLG);
	pdlg = &pd;
	return CDocument::OnSaveDocument(lpszPathName);
}

void CDSPDoc::OnClear() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	int s = v->GetStartPos() * GetSampleSize();
	int N = (v->GetEndPos() + 1) * GetSampleSize() - s;
	if (h.wBitsPerSample == 8)
		memset(data + s, 0x80, N);
	else
		memset(data + s, 0, N);
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}


BOOL CDSPDoc::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	// TODO: Add your specialized code here and/or call the base class
	if (nID == ID_FILE_NEW && !nCode)
		if (newdoc.DoModal() != IDOK) return true;
	
	return CDocument::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CDSPDoc::OnFileRecord() 
{
	// TODO: Add your command handler code here
	if (!SaveModified()) return;
	if (recdlg.DoModal() != IDOK) return;
	if (!CDocument::OnNewDocument()) return;
	this->SetTitle("");

	int smp_rate = GetSampleRate(recdlg.m_SmpRate);
	strcpy(h.RIFF, "RIFF");
	strcpy(h.wavefmt, "WAVEfmt ");
	h.size = sizeof(h.w) + 2;
	memcpy(&h.w, &recdlg.wf1, sizeof(WAVEFORMATEX));
	strcpy(h.data, "data");
	h.size2 = (recdlg.datasize);
	h.file_length = sizeof(h.w) + h.size2 - 8;

	data = recdlg.data;

	SetModifiedFlag();
	UpdateAllViews(NULL);
}


void CDSPDoc::OnUpdateRemovedc(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnRemovedc() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	unsigned int start, N;

	if (v->GetStartPos() == v->GetEndPos())
	{
		start = 0;
		N = h.size2 / GetSampleSize();
	}
	else
	{
		start = v->GetStartPos() * GetSampleSize();
		N = v->GetSelectionSize();
	}

	CProgressDlg pd;
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);
	SetProgressDlg(&pd);

	for (int i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + start, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		RemoveDCOffset(s);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnMovingavg() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	int s1 = v->GetStartPos();
	int e1 = v->GetEndPos();
	int StartPos, N;
	avgdlg.m_ApplyTo = (s1 != e1) ? 1 : 0;

	if (avgdlg.DoModal() != IDOK) return;

	if (avgdlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}
	
	CProgressDlg pdlg;
	pdlg.m_Text = _T("   ...");
	pdlg.Create(IDD_PROGRESSDLG);
	SetProgressDlg(&pdlg);

	for (int i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), 
			(h.w.nChannels == 2), i);
		MovingAverageFilter(s, avgdlg.m_NumPoints);
	}

	pdlg.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateMovingavg(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);		
}

void CDSPDoc::OnUpdateChebyshev(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnChebyshev() 
{
	// TODO: Add your command handler code here
	ApplyFilter(0, false, true, true);
}

void CDSPDoc::OnUpdateEcho(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnEcho()
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;
	double delay, decay, echo_amp, input_amp;

	echodlg.m_ApplyTo = ApplyTo;
	if (echodlg.DoModal() != IDOK) return;

	if (echodlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	delay = echodlg.m_DelayTime;
	decay = echodlg.m_DecayTime;
	if (decay <= delay) return;
	decay = pow(10, -3 * delay / decay);

	echo_amp = -(double)echodlg.m_EchoAmp / 20;
	if (echo_amp == -4.0)
		echo_amp = 0.0;
	else
		echo_amp = pow(10, echo_amp);

	input_amp = -(double)echodlg.m_InputAmp / 20;
	if (input_amp == -4.0)
		input_amp = 0.0;
	else
		input_amp = pow(10, input_amp);

	CProgressDlg pd;
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);
	SetProgressDlg(&pd);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		Echo(s, delay, decay, input_amp, echo_amp, (echodlg.m_MultyEcho == 1), h.w.nSamplesPerSec);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateAmpmod(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::ModSynth(bool IsSynth)
{
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;

	ampdlg.m_IsSynth = IsSynth;
	ampdlg.m_ApplyTo = ApplyTo;
	ampdlg.m_HalfRate = h.w.nSamplesPerSec >> 1;
	if (ampdlg.DoModal() != IDOK) return;

	if (ampdlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);
	SetProgressDlg(&pd);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		if (!IsSynth)
			AmplitudeModulation(s, ampdlg.m_ModFreq, ampdlg.m_Phase, 
				ampdlg.m_ModDepth, h.w.nSamplesPerSec, ampdlg.m_WaveForm);
		else
			WaveSynth(s, ampdlg.m_ModFreq, ampdlg.m_Phase, 
				ampdlg.m_ModDepth, h.w.nSamplesPerSec, ampdlg.m_WaveForm);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnAmpmod() 
{
	// TODO: Add your command handler code here
	ModSynth(false);
}

void CDSPDoc::OnUpdateConvolution(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnConvolution() 
{
	// TODO: Add your command handler code here
	ApplyFilter(5, true, true, true);
}

void CDSPDoc::OnUpdateLogarithming(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnLogarithming() 
{
	// TODO: Add your command handler code here
	homodlg.m_IsFourier = false;
	homodlg.pDoc = this;
	if (homodlg.DoModal() != IDOK) return;
	SetTransformFlag(1);
	ApplyFilter(homodlg.m_FilterType, true, false, true);
	SetTransformFlag(0);
}

void CDSPDoc::OnUpdateFourier(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnFourier() 
{
	// TODO: Add your command handler code here
	homodlg.m_IsFourier = true;
	homodlg.pDoc = this;
	if (homodlg.DoModal() != IDOK) return;
	SetTransformFlag(2);
	ApplyFilter(homodlg.m_FilterType, true, false, true);
	SetTransformFlag(0);
}

void CDSPDoc::OnUpdateIirdesign(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnIirdesign() 
{
	// TODO: Add your command handler code here
	ApplyFilter(1, false, true, true);
}

void CDSPDoc::OnUpdate3ddesign(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::On3ddesign() 
{
	// TODO: Add your command handler code here
	ApplyFilter(6, true, true, true);
}

void CDSPDoc::OnUpdateSynth(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnSynth() 
{
	// TODO: Add your command handler code here
	ModSynth(true);	
}

void CDSPDoc::OnUpdateSetsamples(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);
}

void CDSPDoc::OnSetsamples() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);
	if (smpdlg.DoModal() != IDOK) return;	
	int s, e, t;
	int m_nSamples = h.size2 / (h.w.nChannels * h.wBitsPerSample >> 3);
	double d;

	if (smpdlg.m_FormType)
	{
		s = int((smpdlg.m_FromH * 3600000 + smpdlg.m_FromM * 60000 + 
			smpdlg.m_FromS * 1000 + smpdlg.m_FromT) * 0.001 * h.w.nSamplesPerSec);
		e = int((smpdlg.m_ToH * 3600000 +
			smpdlg.m_ToM * 60000 + smpdlg.m_ToS * 1000 + smpdlg.m_ToT) * 0.001 * h.w.nSamplesPerSec);
	}
	else
	{
		s = smpdlg.m_FromN;
		e = smpdlg.m_ToN;
	}

	if (smpdlg.m_GroupSize)
	{
		if (e < s)
		{
			t = s;
			s = e;
			e = t;
		}
	}
	else
		e = s;

	d = smpdlg.m_SampleVal;
	if (h.wBitsPerSample == 16)
		d *= 32767;
	else
		d *= 127;

	for (int i = 0; i < h.w.nChannels; i++)
	{
		SampleData sd(m_nSamples, data, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		for (int j = s; j <= e; j++)
		{
			if (j >= m_nSamples) break;
			sd.SetSample(j, d);		
		}
	}

	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateAddnoise(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnAddnoise() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;

	noisedlg.m_ApplyTo = ApplyTo;
	noisedlg.m_HalfRate = h.w.nSamplesPerSec >> 1;
	if (noisedlg.DoModal() != IDOK) return;

	if (noisedlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	SetProgressDlg(&pd);
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		AddNoise(s, noisedlg.m_NoiseFreq, noisedlg.m_NoiseVal, h.w.nSamplesPerSec);
	}

	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateFade(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnFade() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;

	fadedlg.m_ApplyTo = ApplyTo;
	if (fadedlg.DoModal() != IDOK) return;

	if (fadedlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	SetProgressDlg(&pd);
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		Fade(s, fadedlg.m_FadeType, fadedlg.m_FadeIn == 1);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdatePitchshift(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnPitchshift() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;

	pitchdlg.m_ApplyTo = ApplyTo;
	if (pitchdlg.DoModal() != IDOK) return;

	if (pitchdlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	SetProgressDlg(&pd);
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		PitchShift(s, pitchdlg.m_ShiftBy);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateChorus(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnChorus() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;

	chorusdlg.m_ApplyTo = ApplyTo;
	if (chorusdlg.DoModal() != IDOK) return;

	if (chorusdlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	SetProgressDlg(&pd);
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		Chorus(s, chorusdlg.m_ChorusSize, chorusdlg.m_ChorusDelay,
			chorusdlg.m_ModFreq, chorusdlg.m_ModDepth, chorusdlg.m_InputAmp, 
			chorusdlg.m_ChorusAmp, h.w.nSamplesPerSec);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateReverb(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnReverb() 
{
	// TODO: Add your command handler code here
	
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;
	int e_p = 0, t_p = 0;
	double early[3], tail[4], ea[4];

	reverbdlg.m_ApplyTo = ApplyTo;
	if (reverbdlg.DoModal() != IDOK) return;

	if (reverbdlg.m_ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	memset(early, 0, sizeof(double) * 4);
	memset(tail, 0, sizeof(double) * 5);
	early[0] = reverbdlg.m_EarlyDel1;
	early[1] = reverbdlg.m_EarlyDel2;
	early[2] = reverbdlg.m_EarlyDel3;
	ea[0] = reverbdlg.m_EarlyAmp1;
	ea[1] = reverbdlg.m_EarlyAmp2;
	ea[2] = reverbdlg.m_EarlyAmp3;
	tail[0] = reverbdlg.m_TailDelay1;
	tail[1] = reverbdlg.m_TailDelay2;
	tail[2] = reverbdlg.m_TailDelay3;
	tail[3] = reverbdlg.m_TailDelay4;

	CProgressDlg pd;
	SetProgressDlg(&pd);
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		Reverberation(s, reverbdlg.m_InputAmp, reverbdlg.m_EarlyAmp,
			reverbdlg.m_ReverbAmp, early, ea, tail, reverbdlg.m_PreDelay,
			reverbdlg.m_ReverbTime, h.w.nSamplesPerSec);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}

void CDSPDoc::OnUpdateReverse(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	pCmdUI->Enable(!IsPlaying);	
}

void CDSPDoc::OnReverse() 
{
	// TODO: Add your command handler code here
	POSITION p = GetFirstViewPosition();
	CDSPView *v = (CDSPView *)GetNextView(p);

	int s1 = v->GetStartPos(), N;
	int e1 = v->GetEndPos(), i;
	int ApplyTo = (s1 != e1) ? 1 : 0;

	if (ApplyTo == 1)
	{
		StartPos = s1 * GetSampleSize();
		N = e1 - s1 + 1;
	}
	else
	{
		StartPos = 0;
		N = h.size2 / GetSampleSize();
	}

	CProgressDlg pd;
	SetProgressDlg(&pd);
	pd.m_Text = _T("   ...");
	pd.Create(IDD_PROGRESSDLG);

	for (i = 0; i < h.w.nChannels; i++)
	{
		SampleData s(N, data + StartPos, (h.wBitsPerSample == 16), (h.w.nChannels == 2), i);
		Reverse(s);
	}

	pd.DestroyWindow();
	SetModifiedFlag();
	v->InvalidateRect(NULL, FALSE);
}
