// EchoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dsp.h"
#include "EchoDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEchoDlg dialog


CEchoDlg::CEchoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEchoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEchoDlg)
	m_ApplyTo = -1;
	m_DecayTime = 1.0;
	m_DelayTime = 0.1;
	m_EchoAmp = 0;
	m_InputAmp = 0;
	m_MultyEcho = TRUE;
	//}}AFX_DATA_INIT
}


void CEchoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEchoDlg)
	DDX_CBIndex(pDX, IDC_APPLYTO, m_ApplyTo);
	DDX_Text(pDX, IDC_DECAYTIME, m_DecayTime);
	DDV_MinMaxDouble(pDX, m_DecayTime, 1.e-003, 100.);
	DDX_Text(pDX, IDC_DELAYTIME, m_DelayTime);
	DDV_MinMaxDouble(pDX, m_DelayTime, 1.e-004, 10.);
	DDX_Slider(pDX, IDC_ECHOAMP, m_EchoAmp);
	DDX_Slider(pDX, IDC_INPUTAMP, m_InputAmp);
	DDX_Check(pDX, IDC_MULTYECHO, m_MultyEcho);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEchoDlg, CDialog)
	//{{AFX_MSG_MAP(CEchoDlg)
	ON_WM_VSCROLL()
	ON_WM_SHOWWINDOW()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEchoDlg message handlers

BOOL CEchoDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	
	if (!m_ApplyTo)
	{
		CComboBox *cb = (CComboBox *)GetDlgItem(IDC_APPLYTO);
		cb->DeleteString(1);
	}
	CSliderCtrl *sl = (CSliderCtrl *)GetDlgItem(IDC_INPUTAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(80);
	sl->SetTicFreq(6);
	sl = (CSliderCtrl *)GetDlgItem(IDC_ECHOAMP);
	sl->SetRangeMin(0);
	sl->SetRangeMax(80);
	sl->SetTicFreq(6);

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEchoDlg::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	// TODO: Add your message handler code here and/or call default
	int id = -1, pos;
	double p;

	CSliderCtrl *sl = (CSliderCtrl *)pScrollBar;
	char s[20];

	switch (sl->GetDlgCtrlID())
	{
		case IDC_INPUTAMP: id = IDC_VAL1; break;
		case IDC_ECHOAMP: id = IDC_VAL2; break;
	}

	if (id > 0)
	{
		pos = -sl->GetPos();
		if (pos > -80)
		{
			p = pow(10, (double)pos / 20) * 100;
			sprintf(s, "%d \n(%.2f%c)", pos, p, '%');
		}
		else
			strcpy(s, "-Inf \n(0%)");
		SetDlgItemText(id, s);
	}

	CDialog::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CEchoDlg::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	// TODO: Add your message handler code here
	
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_INPUTAMP));
	OnVScroll(0, 0, (CScrollBar *)GetDlgItem(IDC_ECHOAMP));
}
